> ## Documentation Index
> Fetch the complete documentation index at: https://dripart-chore-mintlify-theme-mint.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# 使用 Comfy Router 进行图生视频

> 通过 Comfy Router 调用 moonvalley/image-to-video：端点、请求结构以及 Router 返回的响应。

`moonvalley/image-to-video` 的 API 参考，由 Comfy Router 提供，模型来自 Moonvalley。

## 快速开始

在[你的 Comfy 工作区](https://platform.comfy.org/profile/api-keys?onboarding=router)中创建密钥，并将其导出为 `COMFY_API_KEY`。Python、TypeScript 和 Swift 代码片段使用 Comfy SDK（`pip install comfy-sdk`、`npm install @comfyorg/sdk`，以及 [`ComfySwiftSDK`](https://github.com/Comfy-Org/comfy-swift-sdk) Swift 包）；cURL 代码片段则是通过原生 HTTP 发送的同一调用。

**模型 ID：** `moonvalley/image-to-video`

**端点：** `POST https://api.comfy.org/v2/models/moonvalley/image-to-video`

<Tabs>
  <Tab title="等待结果">
    <CodeGroup>
      ```python Python theme={null}
      from comfy_sdk import Comfy

      # 从环境变量中读取 COMFY_API_KEY。
      # SDK 会自动创建幂等键，并在自动重试时复用它。
      with Comfy() as client:
          result = client.models.run(
              "moonvalley/image-to-video",
              {
                  "image_url": "https://yavuzceliker.github.io/sample-images/image-1021.jpg",
                  "prompt_text": "a single red maple leaf falling onto still water",
              },
          )

      print(result)
      ```

      ```typescript TypeScript theme={null}
      import { comfy } from "@comfyorg/sdk";

      // 从环境变量中读取 COMFY_API_KEY。
      // SDK 会自动创建幂等键，并在自动重试时复用它。
      const { data } = await comfy.models.run("moonvalley/image-to-video", {
        image_url: "https://yavuzceliker.github.io/sample-images/image-1021.jpg",
        prompt_text: "a single red maple leaf falling onto still water",
      });

      console.log(data);
      ```

      ```swift Swift theme={null}
      import Foundation
      import ComfySwiftSDK

      // 从环境变量中读取 COMFY_API_KEY。
      // SDK 每次调用都会生成一个幂等键，并在自动重试时复用它。
      let client = ComfyCloudClient(apiKey: ProcessInfo.processInfo.environment["COMFY_API_KEY"]!)
      let result = try await client.models.run(
          "moonvalley/image-to-video",
          input: [
              "image_url": "https://yavuzceliker.github.io/sample-images/image-1021.jpg",
              "prompt_text": "a single red maple leaf falling onto still water",
          ]
      )

      print(result.output)
      ```

      ```bash cURL theme={null}
      curl https://api.comfy.org/v2/models/moonvalley/image-to-video \
        -H "X-API-Key: $COMFY_API_KEY" \
        -H "Idempotency-Key: $(uuidgen)" \
        -H "Content-Type: application/json" \
        -d "{\"image_url\": \"https://yavuzceliker.github.io/sample-images/image-1021.jpg\", \"prompt_text\": \"a single red maple leaf falling onto still water\"}"
      ```
    </CodeGroup>
  </Tab>

  <Tab title="入队并稍后收集">
    相同的请求体，发送至 `POST https://api.comfy.org/v2/models/moonvalley/image-to-video/requests`。运行一旦被接纳，Router 就会返回 `201` 和一个 `request_id`；结果就绪后即可收集，无论是在当前进程还是其他进程中。[队列投递](/zh/development/comfy-router/queue) 会详细讲解状态查询、取消与结果收集。

    <CodeGroup>
      ```python Python theme={null}
      from comfy_sdk import Comfy

      # 从环境变量中读取 COMFY_API_KEY。
      # 每次 submit() 调用都会自行生成 Idempotency-Key，并在自动重试时复用。
      with Comfy() as client:
          handle = client.models.submit(
              "moonvalley/image-to-video",
              {
                  "image_url": "https://yavuzceliker.github.io/sample-images/image-1021.jpg",
                  "prompt_text": "a single red maple leaf falling onto still water",
              },
          )
          print("request_id:", handle.request_id)  # 配合模型 ID，就是另一个进程所需的全部信息

          # 轮询直到请求完成，等待时长遵循服务器返回的 Retry-After。
          for update in handle.iter_events():
              print(update.status, update.queue_position)

          # 提供商自己的载荷，与 models.run() 返回的值相同。
          # 失败或已取消的请求会在此处抛出带类型的 Router 错误。
          result = handle.get()

      print(result)
      ```

      ```typescript TypeScript theme={null}
      import { comfy } from "@comfyorg/sdk";

      // 从环境变量中读取 COMFY_API_KEY。
      // 每次 submit() 调用都会自行生成 Idempotency-Key，并在自动重试时复用。
      const handle = await comfy.models.submit("moonvalley/image-to-video", {
        image_url: "https://yavuzceliker.github.io/sample-images/image-1021.jpg",
        prompt_text: "a single red maple leaf falling onto still water",
      });
      console.log("requestId:", handle.requestId); // 配合模型 ID，就是另一个进程所需的全部信息

      // 轮询直到请求完成，等待时长遵循服务器返回的 Retry-After。
      for await (const update of handle.events()) {
        console.log(update.status, update.queuePosition);
      }

      // 与 models.run() 返回的结果相同。失败或已取消的请求会在此处 reject。
      const result = await handle.get();

      console.log(result.data);
      ```

      ```swift Swift theme={null}
      import Foundation
      import ComfySwiftSDK

      // 从环境变量中读取 COMFY_API_KEY。
      // 每次 submit() 调用都会自行生成 Idempotency-Key，并在自动重试时复用。
      let client = ComfyCloudClient(apiKey: ProcessInfo.processInfo.environment["COMFY_API_KEY"]!)
      let handle = try await client.models.submit(
          "moonvalley/image-to-video",
          input: [
              "image_url": "https://yavuzceliker.github.io/sample-images/image-1021.jpg",
              "prompt_text": "a single red maple leaf falling onto still water",
          ]
      )
      print("requestId:", handle.requestId)  // 配合模型 ID，就是另一个进程所需的全部信息

      // 轮询直到请求完成，等待时长遵循服务器返回的 Retry-After。
      for try await update in handle.events() {
          print(update.state.rawValue, update.queuePosition.map(String.init) ?? "unknown")
      }

      // 提供商自己的载荷，与 models.run() 返回的值相同。
      // 失败或已取消的请求会在此处抛出带类型的 Router 错误。
      let result = try await handle.result()

      print(result.output)
      ```

      ```bash cURL theme={null}
      # 1. 提交。Router 返回 201 以及 request_id、status_url、response_url 和 cancel_url。
      curl https://api.comfy.org/v2/models/moonvalley/image-to-video/requests \
        -H "X-API-Key: $COMFY_API_KEY" \
        -H "Idempotency-Key: $(uuidgen)" \
        -H "Content-Type: application/json" \
        -d "{\"image_url\": \"https://yavuzceliker.github.io/sample-images/image-1021.jpg\", \"prompt_text\": \"a single red maple leaf falling onto still water\"}"

      # 2. 轮询直到状态为 COMPLETED，每次响应中指定的 Retry-After 秒数即为等待时长。
      REQUEST_ID="<request_id from the 201 body>"
      curl -i https://api.comfy.org/v2/models/moonvalley/image-to-video/requests/$REQUEST_ID/status \
        -H "X-API-Key: $COMFY_API_KEY"

      # 3. 收集结果。返回 200 时为模型的原生输出；仍在运行时返回 202 及状态响应体。
      curl https://api.comfy.org/v2/models/moonvalley/image-to-video/requests/$REQUEST_ID \
        -H "X-API-Key: $COMFY_API_KEY"
      ```
    </CodeGroup>
  </Tab>
</Tabs>

## Schema

### 输入

<ParamField body="image_url" type="string" />

<ParamField body="inference_params" type="object" />

<ParamField body="inference_params.guidance_scale" type="number" default="10">
  用于控制生成的引导缩放

  格式：`float`
</ParamField>

<ParamField body="inference_params.height" type="integer" default="1080">
  已生成视频的高度（像素）
</ParamField>

<ParamField body="inference_params.negative_prompt" type="string">
  负面提示词文本
</ParamField>

<ParamField body="inference_params.seed" type="integer" default="9">
  用于生成的随机种子（默认：随机）
</ParamField>

<ParamField body="inference_params.steps" type="integer" default="80">
  去噪步数
</ParamField>

<ParamField body="inference_params.use_negative_prompts" type="boolean" default="true">
  是否使用负面提示词
</ParamField>

<ParamField body="inference_params.width" type="integer" default="1920">
  已生成视频的宽度（像素）
</ParamField>

<ParamField body="prompt_text" type="string" />

<ParamField body="webhook_url" type="string" />

<ParamField body="keyframes" type="object" />

该文档由 Router 在 `GET /v2/models/moonvalley/image-to-video/openapi.json` 处提供，与请求到达提供商之前 Router 用于校验调用的文档相同。

### 输出

<ResponseField name="error" type="object" />

<ResponseField name="frame_conditioning" type="object" />

<ResponseField name="id" type="string" />

<ResponseField name="inference_params" type="object" />

<ResponseField name="meta" type="object" />

<ResponseField name="model_params" type="object" />

<ResponseField name="output_url" type="string" required />

<ResponseField name="prompt_text" type="string" />

<ResponseField name="status" type="string" required />

## 示例

### 输入

```json theme={null}
{
  "image_url": "https://yavuzceliker.github.io/sample-images/image-1021.jpg",
  "prompt_text": "a single red maple leaf falling onto still water"
}
```

### 输出

```json theme={null}
{
  "id": "018f2c7a-4b1e-7c3d-9a05-6e2f8b41d0c9",
  "output_url": "https://example.invalid/moonvalley/prompts/output.mp4",
  "prompt_text": "a single red maple leaf falling onto still water",
  "status": "completed"
}
```

## 发布前须知

SDK 会生成 `Idempotency-Key` 并在自动重试中复用它。手动重试时，请复用原始 key。Router 最长可保持连接 10 分钟。

请求失败时，Router 会发送 `X-Comfy-Error-Type` 响应头说明原因。`422` 表示 Router 在调用提供商之前就拒绝了输入，`413` 表示请求体超出了 Router 可接受的大小。已生成的资源请及时下载，因为[结果 URL 会过期](/zh/development/comfy-router/reference#结果资产)。

上文任何字段描述中提到的尺寸限制，都是提供商对该字段自身的限定，引自提供商的规范。Router 会对整个请求体另行设置上限，base64 编码的媒体内容也计入其中：参见[请求体大小](/zh/development/comfy-router/limitations)。

本页记录的是通过 Comfy Router 调用的某一个合作伙伴模型。同一个 `comfy-sdk` / `@comfyorg/sdk` 包还提供第二个客户端，用于在 Comfy Cloud 上运行完整的 ComfyUI 工作流图：`Comfy(api_key=...)` / `new Comfy({ apiKey })`，并带有 `client.workflows`、`client.assets` 和 `client.jobs`。请参阅 [Comfy SDKs](/zh/development/api-development/sdks)。

<CardGroup cols={3}>
  <Card title="请求头" icon="list" href="/zh/development/comfy-router/headers">
    身份验证、幂等性、请求 ID、错误分类、重试节奏、消费限额。
  </Card>

  <Card title="使用 Router API" icon="code" href="/zh/development/comfy-router/api">
    模型发现、验证错误、重试与计费。
  </Card>

  <Card title="限制" icon="triangle-exclamation" href="/zh/development/comfy-router/limitations">
    Router 目前不支持的功能，以及替代方案。
  </Card>
</CardGroup>
